/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/*                                                                      */
/************************************************************************/
#include "main.h"

int main( void )
{
  uint i;
  char s[30];
  int Keycode;
	

  // Crystal Oscillator division factor: 1
  #pragma optsize-
  CLKPR=0x80;
  CLKPR=0x00;
  #ifdef _OPTIMIZE_SIZE_
  #pragma optsize+
  #endif



  // Input/Output Ports initialization
  // Port A initialization
  // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
  // State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=T 
  PORTA=0x00;
  DDRA=0x08;

	
  TCCR0A=0x00;
  TCCR0B=0x04;//divide by 256
  TCNT0=0x00;
  OCR0A=0x00;
  OCR0B=0x00;			
  TIMSK0 = 1<<TOIE0;		//enable timer interrupt

  sei();


  for(;;){					// main loop

//	for (i=0;i<=50;i++)
//		_delay_ms(10);

//	PORTA ^= 1<<PA3;


    cli();
    i = rc5_data;			// read two bytes from interrupt !
    rc5_data = 0;
    sei();

    if( i ){
      Keycode = ((i & 0x3F) | (~i >> 7 & 0x40), s, 10); // Key Code
	  if (Keycode==1)
	  	PORTA |= (1<<PA3);
	  else
	  	PORTA &= ~(1<<PA3);
    }
  }
}
